<?php 
##
#	Project: PHPDisk Personal Edition
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: account.php 248 2009-10-17 06:03:28Z along $
#
#	Copyright (C) 2008-2009 PHPDisk Team. All Rights Reserved.
#
##

include "includes/commons.inc.php";

$in_front = true;

require_once lang('account');
$lang = array_merge($pub_lang,$lang);
$title = $lang['account'][$action];
include PHPDISK_ROOT."./includes/header.inc.php";

switch($action){
	case 'relogin':
	case 'login':

		if($task =='login'){

			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$username = $db->escape(gpc('username','P',''));
			$password = $db->escape(gpc('password','P',''));
			$md5_pwd = md5($password);
			$remember = (int)gpc('remember','P',0);
			$verycode = trim(gpc('verycode','P',''));
			$ref = trim(gpc('ref','P',''));
			
			if(checklength($username,2,60)){
				$error = true;
				$sysmsg[] = $lang['invalid_username'];
			}
			if(checklength($password,6,20)){
				$error = true;
				$sysmsg[] = $lang['invalid_password'];
			}
			if($settings['login_verycode']){
				session_start();
				if (!$verycode || strtolower($verycode) != strtolower($_SESSION['verycode'])) {
					unset($_SESSION['verycode']);
					$error = true;
					$sysmsg[] = $lang['invalid_verycode'];
				}
			}
			
			$rs = $db->fetch_one_array("select userid,gid,username,password,email,is_locked from {$tpf}users where username='$username' limit 1");
			if(!$rs){
				$error = true;
				$sysmsg[] = $lang['user_not_exists'];
			}else{
				if($md5_pwd != $rs['password']){
					$error = true;
					$sysmsg[] = $lang['user_password_false'];
				}elseif($rs['is_locked']){
					$error = true;
					$sysmsg[] = $lang['user_is_locked'];
				}else{
					$userid = (int)$rs['userid'];
					$gid = (int)$rs['gid'];
					$username = trim($rs['username']);
					$password = trim($rs['password']);
					$email = trim($rs['email']);
				}
			}
						if(!$settings['allow_access'] && $gid !=1){
				$error = true;
				$sysmsg[] = $lang['admin_not_valid'];
			}
			if(!$error){
				$credit = $settings['credit_open'] ? (int)$settings['credit_login'] : 0;
				$sql_do = $credit ? ", credit=credit+{$credit}" : "";
				$db->query_unbuffered("update {$tpf}users set last_login_ip='$onlineip',last_login_time='$timestamp' {$sql_do} where userid='$userid'");
				if($remember){
					pd_setcookie('phpdisk_info',pd_encode("$userid\t$gid\t$username\t$password\t$email"),86400*30);
				}else{
					pd_setcookie('phpdisk_info',pd_encode("$userid\t$gid\t$username\t$password\t$email"));
				}
				redirect($ref ? $ref : urr("index",""),'',0);
			}
		} 
				if(!$settings['allow_access']){
			$sysmsg[] = $lang['close_access'];
		}
		$user_title = $lang['user_login'];
		require_once template_echo('pd_account',TPL_NAME);

	break;
	
	case 'adminlogin':
	
		$username = $pd_username;
		
		if($task =='adminlogin'){

			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$username = $db->escape(gpc('username','P',''));
			$password = $db->escape(gpc('password','P',''));
			$md5_pwd = md5($password);

			if(checklength($username,2,60)){
				$error = true;
				$sysmsg[] = $lang['invalid_username'];
			}
			if(checklength($password,6,20)){
				$error = true;
				$sysmsg[] = $lang['invalid_password'];
			}
			$rs = $db->fetch_one_array("select userid,gid,username,password,email from {$tpf}users where username='$username' limit 1");
			if(!$rs){
				$error = true;
				$sysmsg[] = $lang['user_not_exists'];
			}else{
				if($md5_pwd != $rs['password']){
					$error = true;
					$sysmsg[] = $lang['user_password_false'];
				}else{
					$userid = (int)$rs['userid'];
					$gid = (int)$rs['gid'];
					$username = trim($rs['username']);
					$password = trim($rs['password']);
					$email = trim($rs['email']);
				}
			}
			
			if(!$error && $gid ==1 && $pd_uid){
				$ins = array(
					'userid' => $pd_uid,
					'login_time' => $timestamp,
					'hashcode' => gpc('phpdisk_info','C',''),
					'ip' => $onlineip,
				);
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}adminsession where userid='$pd_uid'");
				if($rs['total'] ==0){
					$db->query("replace into {$tpf}adminsession set ".$db->sql_array($ins).";");
				}else{
					$db->query("update {$tpf}adminsession set ".$db->sql_array($ins)." where userid='$pd_uid' and $timestamp-login_time >10");
				}
				unset($rs);
				redirect(urr("admincp",""),'',0);
			}else{
				if(!count($sysmsg)){
					$sysmsg[] = $lang['admin_not_valid'];
				}
			}
		}
		$user_title = $lang['admin_login'];
		require_once template_echo('pd_account',TPL_NAME);
	break;
	
	case 'register':

		if($task == 'register'){
			
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$username = trim(gpc('username','P',''));
			$password = trim(gpc('password','P',''));
			$confirm_password = trim(gpc('confirm_password','P',''));
			$email = trim(gpc('email','P',''));
			$verycode = trim(gpc('verycode','P',''));
			$invite_uid = (int)gpc('invite_uid','P',0);
			
			if(checklength($username,2,60)){
				$error = true;
				$sysmsg[] = $lang['invalid_username'];
			}elseif(is_bad_chars($username)){
				$error = true;
				$sysmsg[] = $lang['username_has_bad_chars'];
			}else{
				$rs = $db->fetch_one_array("select username from {$tpf}users where username='".$db->escape($username)."' limit 1");
				if($rs){
					if(strcasecmp($username,$rs['username']) ==0){
						$error = true;
						$sysmsg[] = $lang['username_already_exists'];
					}
				}else{
					$username = $db->escape($username);
				}
				unset($rs);
			}
			if(checklength($password,6,20)){
				$error = true;
				$sysmsg[] = $lang['invalid_password'];
			}else{
				if($password == $confirm_password){
					$md5_pwd = md5($password);
				}else{
					$error = true;
					$sysmsg[] = $lang['confirm_password_invalid'];
				}
			}
			if(!checkemail($email)){
				$error = true;
				$sysmsg[] = $lang['invalid_email'];
			}else{
				$rs = $db->fetch_one_array("select email from {$tpf}users where email='".$db->escape($email)."' limit 1");
				if($rs){
					if(strcasecmp($email,$rs['email']) ==0){
						$error = true;
						$sysmsg[] = $lang['email_already_exists'];
					}
					unset($rs);
				}else{
					$email = $db->escape($email);
				}
			}
			if($settings['register_verycode']){
				session_start();
				if (!$verycode || strtolower($verycode) != strtolower($_SESSION['verycode'])) {
					unset($_SESSION['verycode']);
					$error = true;
					$sysmsg[] = $lang['invalid_verycode'];
				}
			}
			$credit = $settings['credit_open'] ? (int)$settings['credit_reg'] : 0;
			if(!$error){
				$ins = array(
					'username' => $username,
					'password' => $md5_pwd,
					'email' => $email,
					'gid' => 4,
					'credit' => $credit,
					'reg_time' => $timestamp,
					'reg_ip' => $onlineip,
				);
				$db->query("insert into {$tpf}users set ".$db->sql_array($ins).";");
				$userid = $db->insert_id();
				
				$ins2 = array(
					'userid' => $invite_uid,
					'touserid' => $userid,
					'in_time' => $timestamp,
				);
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}buddys where userid='$invite_uid' and touserid='$userid'");
				if(!$rs['total']){
					$db->query_unbuffered("insert into {$tpf}buddys set ".$db->sql_array($ins2).";");
					$credit_invite = $settings['credit_open'] ? (int)$settings['credit_invite'] : 0;
					$db->query_unbuffered("update {$tpf}users set credit=credit+$credit_invite where userid='$invite_uid'");
				}
				unset($rs);
				
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}users ");
				if($rs){
					$db->query("replace into {$tpf}stats (vars,value) values('users_count','".$rs['total']."');");
					write_cache('stats');
				}
				unset($rs);
				$sysmsg[] = $lang['register_success'];
				$reg_success = 1;
			}else{
				redirect('javascript:history.back();',$sysmsg);
			}
		}
		if(!$settings['allow_register']){
			$sysmsg[] = $lang['close_register'];
			if($settings['close_register_reason']){
				$sysmsg[] = 'Tips: '.$settings['close_register_reason'];
			}
		}
		$invite_uid = (int)gpc('uid','G',0);
		if($invite_uid){
			$rs = $db->fetch_one_array("select userid,username from {$tpf}users where userid='$invite_uid' limit 1");
			if($rs){
				$invite_name = $rs['username'];
				$a_space = urr("space","uid={$rs['userid']}");
			}
			unset($rs);
		}
		$user_title = $lang['user_register'];
		require_once template_echo('pd_account',TPL_NAME);
		
	break;
	
	case 'forget_pwd':
		if($task =='forget_pwd'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$username = trim(gpc('username','P',''));
			$verycode = trim(gpc('verycode','P',''));
			
			session_start();
			if (!$verycode || strtolower($verycode) != strtolower($_SESSION['verycode'])) {
				unset($_SESSION['verycode']);
				$sysmsg[] = $lang['invalid_verycode'];
			}else{
				$rs = $db->fetch_one_array("select * from {$tpf}users where username='".$db->escape($username)."'");
				if($rs['userid']){
					$code = md5($rs['userid'].$timestamp);
					$reset_url = $settings['phpdisk_url'].urr("account","action=reset_pwd&code=$code");
					$to = $rs['email'];
					$subject = $lang['reset_pwd_email'];
					$body = $lang['reset_mail_conent']."<br><br><a href=\"{$reset_url}\">$reset_url</a><br><br><br>".$settings['phpdisk_url']."<br>".$settings['email_user'];
					$from = $sender = $username1 = $settings['email_address'];
					$fromname = $settings['email_user'];
					$host = $settings['email_smtp'];
					$port = (int)$settings['email_port'];
					$ssl = (int)$settings['email_ssl'];
					$password = $settings['email_pwd'];
					
					send_email($to,$subject,$body,$from,$fromname,$stmp = true, $sender,$host,$port,$ssl,$username1,$password);
					$db->query_unbuffered("update {$tpf}users set reset_code='$code' where userid='{$rs['userid']}' limit 1");
					$sysmsg[] = $lang['confirm_mail_success'];
	
				}else{
					$sysmsg[] = $lang['user_not_exists'];
				}
				unset($rs);
			}
		}
		require_once template_echo('pd_account',TPL_NAME);
	break;
	
	case 'reset_pwd':
		if($task =='reset_pwd'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$pwd = trim(gpc('pwd','P',''));
			$pwd2 = trim(gpc('pwd2','P',''));
			$userid = (int)gpc('userid','P',0);
			
			if(checklength($pwd,6,20)){
				$error = true;
				$sysmsg[] = $lang['user_password_false'];
			}
			if($pwd !=$pwd2){
				$error = true;
				$sysmsg[] = $lang['confirm_pwd_not_same'];
			}else{
				$md5_pwd = md5($pwd);
			}
			
			if(!$error){
				$db->query_unbuffered("update {$tpf}users set password='$md5_pwd',reset_code='' where userid='$userid' limit 1");
				$sysmsg[] = $lang['reset_pwd_success'];
				echo "<script>setTimeout(function(){document.location='".urr("account","action=login")."'},3000);</script>";
			}
		}else{
			$code = trim(gpc('code','G',''));
			
			if($code){
				$rs = $db->fetch_one_array("select * from {$tpf}users where reset_code='".$db->escape($code)."' limit 1");
				if($rs['userid']){
					$userid = $rs['userid'];
				}else{
					$sysmsg[] = $lang['user_not_exists'];
					$disabled = 'disabled';
				}
			}else{
				$sysmsg[] = $lang['confirm_mail_error'];
				$disabled = 'disabled';
			}
		}
		require_once template_echo('pd_account',TPL_NAME);
	break;
	
	case 'logout':
		pd_setcookie('phpdisk_info','');
		redirect(urr("index",""),'',0);
	break;
	
	case 'demologin':
		if(!$settings['open_demo_login']){
			$sysmsg[] = $pub_lang['demo_login_not_open'];
			require_once template_echo('pd_account',TPL_NAME);
		}else{
			$gid = 4;
			$username = 'phpdisk_demo';
			$password = 'fcf41657f02f88137a1bcf068a32c0a3';
			$email = 'demo@phpdisk.com';
			
			$rs = $db->fetch_one_array("select * from {$tpf}users where username='$username'");
			if(!$rs){
				$ins = array(
					'gid' => $gid,
					'username' => $db->escape($username),
					'password' => $password,
					'email' => $email,
					'reg_ip' => $onlineip,
					'reg_time' => $timestamp,
				);
				$db->query("insert into {$tpf}users set ".$db->sql_array($ins).";");
			
			}else{
				$db->query_unbuffered("update {$tpf}users set last_login_ip='$onlineip',last_login_time='$timestamp' where userid='{$rs['userid']}'");
			}
			unset($rs);
			
			$rs = $db->fetch_one_array("select * from {$tpf}users where username='$username'");
			if($rs){
				$userid = $rs['userid'];
				$gid = $rs['gid'];
				$username = $rs['username'];
				$password = $rs['password'];
				$email = $rs['email'];
			}
			unset($rs);
			
			pd_setcookie('phpdisk_info',pd_encode("$userid\t$gid\t$username\t$password\t$email"));
			
			redirect(urr("mydisk",""),'',0);
		}
	break;

	default:
		redirect(urr("account","action=login"),'',0);
}

include PHPDISK_ROOT."./includes/footer.inc.php";


?>

